# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from .. import tools as _tools
from ._enums import *
from .download import Download
import pulumi_command

__all__ = ['CniPluginsInstallArgs', 'CniPluginsInstall']

@pulumi.input_type
class CniPluginsInstallArgs:
    def __init__(__self__, *,
                 connection: pulumi.Input['pulumi_command.remote.ConnectionArgs'],
                 architecture: Optional[pulumi.Input['Architecture']] = None,
                 directory: Optional[pulumi.Input[str]] = None,
                 version: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a CniPluginsInstall resource.
        :param pulumi.Input['pulumi_command.remote.ConnectionArgs'] connection: The connection details.
        :param pulumi.Input['Architecture'] architecture: The CPU architecture.
        :param pulumi.Input[str] directory: Directory to install the binary.
        :param pulumi.Input[str] version: The version of to install.
        """
        pulumi.set(__self__, "connection", connection)
        if architecture is not None:
            pulumi.set(__self__, "architecture", architecture)
        if directory is None:
            directory = '/usr/local/bin'
        if directory is not None:
            pulumi.set(__self__, "directory", directory)
        if version is not None:
            pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter
    def connection(self) -> pulumi.Input['pulumi_command.remote.ConnectionArgs']:
        """
        The connection details.
        """
        return pulumi.get(self, "connection")

    @connection.setter
    def connection(self, value: pulumi.Input['pulumi_command.remote.ConnectionArgs']):
        pulumi.set(self, "connection", value)

    @property
    @pulumi.getter
    def architecture(self) -> Optional[pulumi.Input['Architecture']]:
        """
        The CPU architecture.
        """
        return pulumi.get(self, "architecture")

    @architecture.setter
    def architecture(self, value: Optional[pulumi.Input['Architecture']]):
        pulumi.set(self, "architecture", value)

    @property
    @pulumi.getter
    def directory(self) -> Optional[pulumi.Input[str]]:
        """
        Directory to install the binary.
        """
        return pulumi.get(self, "directory")

    @directory.setter
    def directory(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "directory", value)

    @property
    @pulumi.getter
    def version(self) -> Optional[pulumi.Input[str]]:
        """
        The version of to install.
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "version", value)


class CniPluginsInstall(pulumi.ComponentResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 architecture: Optional[pulumi.Input['Architecture']] = None,
                 connection: Optional[pulumi.Input[pulumi.InputType['pulumi_command.remote.ConnectionArgs']]] = None,
                 directory: Optional[pulumi.Input[str]] = None,
                 version: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Installs cni-plugins on a remote system.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input['Architecture'] architecture: The CPU architecture.
        :param pulumi.Input[pulumi.InputType['pulumi_command.remote.ConnectionArgs']] connection: The connection details.
        :param pulumi.Input[str] directory: Directory to install the binary.
        :param pulumi.Input[str] version: The version of to install.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: CniPluginsInstallArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Installs cni-plugins on a remote system.

        :param str resource_name: The name of the resource.
        :param CniPluginsInstallArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(CniPluginsInstallArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 architecture: Optional[pulumi.Input['Architecture']] = None,
                 connection: Optional[pulumi.Input[pulumi.InputType['pulumi_command.remote.ConnectionArgs']]] = None,
                 directory: Optional[pulumi.Input[str]] = None,
                 version: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is not None:
            raise ValueError('ComponentResource classes do not support opts.id')
        else:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = CniPluginsInstallArgs.__new__(CniPluginsInstallArgs)

            __props__.__dict__["architecture"] = architecture
            if connection is None and not opts.urn:
                raise TypeError("Missing required property 'connection'")
            __props__.__dict__["connection"] = connection
            if directory is None:
                directory = '/usr/local/bin'
            __props__.__dict__["directory"] = directory
            __props__.__dict__["version"] = version
            __props__.__dict__["archive_name"] = None
            __props__.__dict__["bandwidth_path"] = None
            __props__.__dict__["bridge_path"] = None
            __props__.__dict__["dhcp_path"] = None
            __props__.__dict__["download"] = None
            __props__.__dict__["dummy_path"] = None
            __props__.__dict__["firewall_path"] = None
            __props__.__dict__["host_device_path"] = None
            __props__.__dict__["host_local_path"] = None
            __props__.__dict__["ipvlan_path"] = None
            __props__.__dict__["loopback_path"] = None
            __props__.__dict__["macvlan_path"] = None
            __props__.__dict__["mkdir"] = None
            __props__.__dict__["mktemp"] = None
            __props__.__dict__["mv"] = None
            __props__.__dict__["portmap_path"] = None
            __props__.__dict__["ptp_path"] = None
            __props__.__dict__["rm"] = None
            __props__.__dict__["sbr_path"] = None
            __props__.__dict__["static_path"] = None
            __props__.__dict__["tap_path"] = None
            __props__.__dict__["tar"] = None
            __props__.__dict__["tuning_path"] = None
            __props__.__dict__["url"] = None
            __props__.__dict__["vlan_path"] = None
            __props__.__dict__["vrf_path"] = None
        super(CniPluginsInstall, __self__).__init__(
            'kubernetes-the-hard-way:remote:CniPluginsInstall',
            resource_name,
            __props__,
            opts,
            remote=True)

    @property
    @pulumi.getter
    def architecture(self) -> pulumi.Output['Architecture']:
        """
        The CPU architecture.
        """
        return pulumi.get(self, "architecture")

    @property
    @pulumi.getter(name="archiveName")
    def archive_name(self) -> pulumi.Output[str]:
        return pulumi.get(self, "archive_name")

    @property
    @pulumi.getter(name="bandwidthPath")
    def bandwidth_path(self) -> pulumi.Output[str]:
        return pulumi.get(self, "bandwidth_path")

    @property
    @pulumi.getter(name="bridgePath")
    def bridge_path(self) -> pulumi.Output[str]:
        return pulumi.get(self, "bridge_path")

    @property
    @pulumi.getter
    def connection(self) -> pulumi.Output['pulumi_command.remote.outputs.Connection']:
        """
        The connection details.
        """
        return pulumi.get(self, "connection")

    @property
    @pulumi.getter(name="dhcpPath")
    def dhcp_path(self) -> pulumi.Output[str]:
        return pulumi.get(self, "dhcp_path")

    @property
    @pulumi.getter
    def directory(self) -> pulumi.Output[str]:
        """
        Directory to install the binary.
        """
        return pulumi.get(self, "directory")

    @property
    @pulumi.getter
    def download(self) -> pulumi.Output['Download']:
        return pulumi.get(self, "download")

    @property
    @pulumi.getter(name="dummyPath")
    def dummy_path(self) -> pulumi.Output[str]:
        return pulumi.get(self, "dummy_path")

    @property
    @pulumi.getter(name="firewallPath")
    def firewall_path(self) -> pulumi.Output[str]:
        return pulumi.get(self, "firewall_path")

    @property
    @pulumi.getter(name="hostDevicePath")
    def host_device_path(self) -> pulumi.Output[str]:
        return pulumi.get(self, "host_device_path")

    @property
    @pulumi.getter(name="hostLocalPath")
    def host_local_path(self) -> pulumi.Output[str]:
        return pulumi.get(self, "host_local_path")

    @property
    @pulumi.getter(name="ipvlanPath")
    def ipvlan_path(self) -> pulumi.Output[str]:
        return pulumi.get(self, "ipvlan_path")

    @property
    @pulumi.getter(name="loopbackPath")
    def loopback_path(self) -> pulumi.Output[str]:
        return pulumi.get(self, "loopback_path")

    @property
    @pulumi.getter(name="macvlanPath")
    def macvlan_path(self) -> pulumi.Output[str]:
        return pulumi.get(self, "macvlan_path")

    @property
    @pulumi.getter
    def mkdir(self) -> pulumi.Output['_tools.Mkdir']:
        return pulumi.get(self, "mkdir")

    @property
    @pulumi.getter
    def mktemp(self) -> pulumi.Output['_tools.Mktemp']:
        return pulumi.get(self, "mktemp")

    @property
    @pulumi.getter
    def mv(self) -> pulumi.Output['_tools.Mv']:
        return pulumi.get(self, "mv")

    @property
    @pulumi.getter(name="portmapPath")
    def portmap_path(self) -> pulumi.Output[str]:
        return pulumi.get(self, "portmap_path")

    @property
    @pulumi.getter(name="ptpPath")
    def ptp_path(self) -> pulumi.Output[str]:
        return pulumi.get(self, "ptp_path")

    @property
    @pulumi.getter
    def rm(self) -> pulumi.Output['_tools.Rm']:
        return pulumi.get(self, "rm")

    @property
    @pulumi.getter(name="sbrPath")
    def sbr_path(self) -> pulumi.Output[str]:
        return pulumi.get(self, "sbr_path")

    @property
    @pulumi.getter(name="staticPath")
    def static_path(self) -> pulumi.Output[str]:
        return pulumi.get(self, "static_path")

    @property
    @pulumi.getter(name="tapPath")
    def tap_path(self) -> pulumi.Output[str]:
        return pulumi.get(self, "tap_path")

    @property
    @pulumi.getter
    def tar(self) -> pulumi.Output['_tools.Tar']:
        return pulumi.get(self, "tar")

    @property
    @pulumi.getter(name="tuningPath")
    def tuning_path(self) -> pulumi.Output[str]:
        return pulumi.get(self, "tuning_path")

    @property
    @pulumi.getter
    def url(self) -> pulumi.Output[str]:
        return pulumi.get(self, "url")

    @property
    @pulumi.getter
    def version(self) -> pulumi.Output[str]:
        """
        The version to install.
        """
        return pulumi.get(self, "version")

    @property
    @pulumi.getter(name="vlanPath")
    def vlan_path(self) -> pulumi.Output[str]:
        return pulumi.get(self, "vlan_path")

    @property
    @pulumi.getter(name="vrfPath")
    def vrf_path(self) -> pulumi.Output[str]:
        return pulumi.get(self, "vrf_path")

